//#define NULE 0
//#define MULE 8888

#define true 1
#define false 0

typedef struct NOIDEA_memory
{
	int id;
	int size;
	struct NOIDEA_memory * last;
	struct NOIDEA_memory * next;
} NOIDEA_memory;
/*
typedef struct NOIDEA_yromem
{
	NOIDEA_memory * space;
	int id;
} NOIDEA_yromem;

NOIDEA_memory * NOIDEA_seg (void * , int );
void * NOIDEA_alloc (NOIDEA_memory * , int );
void NOIDEA_free (NOIDEA_memory * , void * );
*/
//==========================

typedef struct NOIDEA_node
{
	void * pack;
	struct NOIDEA_node * last;
	struct NOIDEA_node * next;
} NOIDEA_node;
/*
NOIDEA_node * NOIDEA_create (NOIDEA_node * noidea_src, void * noidea_pack, void * noidea_ptr);
void * NOIDEA_destroy (NOIDEA_node * noidea_src, NOIDEA_node * noidea_nud);
void * NOIDEA_loop (NOIDEA_node * noidea_src);
*/
//==========================

typedef struct NOIDEA_agenda
{
	signed long int wait;		//interval between call
	void (*func)(void);		//function to call
	signed long int till;		//wait till to execute
	signed long int idle;		//time left before execute
	signed long int loop;		//value that end loop
	NOIDEA_node * node;		//the node that list it
} NOIDEA_agenda;
/*
NOIDEA_node * NOIDEA_schedule (NOIDEA_node * , void (*)(void), signed long int  ,void * );
void * NOIDEA_cancel (NOIDEA_node * , NOIDEA_node * );
signed long int NOIDEA_do (NOIDEA_node * , signed long int );


*/
//============================

typedef struct noidea_env
{
	void * self;

	NOIDEA_memory * env;
	void * (*alloc)(struct noidea_env*,int);
	void (*free) (struct noidea_env * , void * );

	NOIDEA_node * list;
	NOIDEA_node * (*append) (struct noidea_env * ,int);
	void * (*remove) (struct noidea_env * ,NOIDEA_node*);
	void * (*next) (struct noidea_env * );

	NOIDEA_node * thread;
	NOIDEA_node * (*start) (struct noidea_env * ,void (*)(void),signed long int);
	void * (*stop) (struct noidea_env * , NOIDEA_node *);
	signed long int (*loop) (struct noidea_env *, signed long int );

}noidea_env;

typedef NOIDEA_node noidea_nod;

noidea_env * noidea_init(void*,int);

//===================================

NOIDEA_node * noidea_insert(noidea_env * noidea_self , char * noidea_str);
char * noidea_extract(NOIDEA_node * noidea_nud);

float noidea_node2float(NOIDEA_node * noidea_nud);
char * noidea_float2str(float noidea_float, int noidea_format);

